import type { OpType } from '../interfaces/type.js'

export const number_type = {
   before: ['Complex'],
   test: (n: unknown): n is number => typeof n === 'number',
   from: { string: (s: string) => +s }
}

declare module "../interfaces/type" {
   interface AssociatedTypes<T> {
      numbers: {
         type: number
         zero: 0
         one: 1
         nan: typeof NaN
         real: number
      }
   }
}

// I don't like the redundancy of repeating 'zero'; any way to eliminate that?
export const zero: OpType<'zero', number> = (a) => 0
export const one:  OpType<'one',  number> = (a) => 1
export const nan:  OpType<'nan',  number> = (a) => NaN
export const re:   OpType<'re',   number> = (a) => a
